commit ed9964e64a81b6a05dabf3c05329bf0c3c6bcdcf
Author: freddy77 <freddy77>
Date:   Wed Nov 12 10:38:15 2008 +0000

    minor fixes

diff --git a/ChangeLog b/ChangeLog
index fac72d5..c28c9e2 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Wed Nov 12 11:36:32 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/dblib/unittests/t0013.c: check field data
+	* src/odbc/prepare_query.c src/odbc/sql2tds.c:
+	- fix error result
+
 Tue Nov 11 19:42:30 EST 2008	JK Lowden <jklowden@freetds.org>
 	* include/dblib.h src/dblib/dblib.c 
 	- dbsqlok did not process entire packet
@@ -935,4 +940,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2659 2008/11/12 00:47:25 jklowden Exp $
+$Id: ChangeLog,v 1.2660 2008/11/12 10:38:15 freddy77 Exp $
diff --git a/src/dblib/unittests/t0013.c b/src/dblib/unittests/t0013.c
index b43e9e1..081bdb7 100644
--- a/src/dblib/unittests/t0013.c
+++ b/src/dblib/unittests/t0013.c
@@ -5,7 +5,7 @@
 
 #include "common.h"
 
-static char software_version[] = "$Id: t0013.c,v 1.23 2006/07/06 12:48:16 freddy77 Exp $";
+static char software_version[] = "$Id: t0013.c,v 1.24 2008/11/12 10:38:15 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 #define BLOB_BLOCK_SIZE 4096
@@ -31,6 +31,7 @@ main(int argc, char **argv)
 	long numread;
 	BOOL readFirstImage;
 	char cmd[1024];
+	int data_ok;
 
 	set_malloc_options();
 
@@ -72,9 +73,9 @@ main(int argc, char **argv)
 		fprintf(stderr, "Cannot open input file: %s\n", argv[1]);
 		return 2;
 	}
-	result = fseek(fp, 0, SEEK_END);
+	fseek(fp, 0, SEEK_END);
 	isiz = ftell(fp);
-	result = fseek(fp, 0, SEEK_SET);
+	fseek(fp, 0, SEEK_SET);
 
 	blob = (char *) malloc(isiz);
 	fread((void *) blob, isiz, 1, fp);
@@ -107,8 +108,6 @@ main(int argc, char **argv)
 	}
 
 	while ((result = dbnextrow(dbproc)) != NO_MORE_ROWS) {
-		result = REG_ROW;
-		result = DBTXPLEN;
 		strcpy(objname, "#dblib0013.PigTure");
 		textPtr = dbtxptr(dbproc, 1);
 		timeStamp = dbtxtimestamp(dbproc, 1);
@@ -201,16 +200,21 @@ main(int argc, char **argv)
 		}
 	}
 
-	printf("Saving first blob data row to file: %s\n", argv[2]);
-	if ((fp = fopen(argv[2], "wb")) == NULL) {
-		fprintf(stderr, "Unable to open output file: %s\n", argv[2]);
-		return 3;
+	data_ok = 1;
+	if (memcmp(blob, rblob, numread) != 0) {
+		printf("Saving first blob data row to file: %s\n", argv[2]);
+		if ((fp = fopen(argv[2], "wb")) == NULL) {
+			fprintf(stderr, "Unable to open output file: %s\n", argv[2]);
+			return 3;
+		}
+		fwrite((void *) rblob, numread, 1, fp);
+		fclose(fp);
+		failed = 1;
+		data_ok = 0;
 	}
-	result = fwrite((void *) rblob, numread, 1, fp);
-	fclose(fp);
 
 	printf("Read blob data row %d --> %s %ld byte comparison\n",
-	       (int) testint, (memcmp(blob, rblob, numread)) ? "failed" : "PASSED", numread);
+	       (int) testint, data_ok ? "PASSED" : "failed", numread);
 	free(rblob);
 
 	if (dbnextrow(dbproc) != NO_MORE_ROWS) {
diff --git a/src/odbc/prepare_query.c b/src/odbc/prepare_query.c
index e4264d1..5a2ed80 100644
--- a/src/odbc/prepare_query.c
+++ b/src/odbc/prepare_query.c
@@ -43,7 +43,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: prepare_query.c,v 1.73 2008/10/16 14:09:57 freddy77 Exp $");
+TDS_RCSID(var, "$Id: prepare_query.c,v 1.74 2008/11/12 10:38:15 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -280,7 +280,7 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 		case SQL_DEFAULT_PARAM:
 			break;	/* OK */
 		default:
-			odbc_errs_add(&stmt->dbc->errs, "HY009", NULL); /* Invalid use of null pointer */
+			odbc_errs_add(&stmt->errs, "HY009", NULL); /* Invalid use of null pointer */
 			return SQL_ERROR;
 		}
 	}		
@@ -302,7 +302,7 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 		break;
 	case SQL_DEFAULT_PARAM:
 		/* FIXME: use the default if the parameter has one. */
-		odbc_errs_add(&stmt->dbc->errs, "07S01", NULL); /* Invalid use of default parameter */
+		odbc_errs_add(&stmt->errs, "07S01", NULL); /* Invalid use of default parameter */
 		return SQL_ERROR;
 	default:
 		if (DataPtr && StrLen_or_Ind < 0) {
@@ -311,7 +311,7 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 			 * the argument StrLen_or_Ind was less than 0 
 			 * but not equal to SQL_NTS or SQL_NULL_DATA."
 			 */
-			odbc_errs_add(&stmt->dbc->errs, "HY090", NULL);
+			odbc_errs_add(&stmt->errs, "HY090", NULL);
 			return SQL_ERROR;
 		}
 		len = StrLen_or_Ind;
@@ -332,7 +332,7 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 		SQLLEN extralen = 0;
 
 		if (0 == (dest_type = odbc_sql_to_server_type(dbc->tds_socket, drec_ipd->sql_desc_concise_type))) {
-			odbc_errs_add(&dbc->errs, "07006", NULL); /* Restricted data type attribute violation */
+			odbc_errs_add(&stmt->errs, "07006", NULL); /* Restricted data type attribute violation */
 			return SQL_ERROR;
 		}
 
@@ -340,7 +340,7 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 		/* TODO test intervals */
 		src_type = odbc_c_to_server_type(sql_src_type);
 		if (src_type == TDS_FAIL) {
-			odbc_errs_add(&stmt->dbc->errs, "07006", NULL); /* Restricted data type attribute violation */
+			odbc_errs_add(&stmt->errs, "07006", NULL); /* Restricted data type attribute violation */
 			return SQL_ERROR;
 		}
 
@@ -404,7 +404,7 @@ continue_parse_prepared_query(struct _hstmt *stmt, SQLPOINTER DataPtr, SQLLEN St
 		if (!p) {
 			free(free_ptr);
 			free(extradata);
-			odbc_errs_add(&dbc->errs, "HY001", NULL); /* Memory allocation error */
+			odbc_errs_add(&stmt->errs, "HY001", NULL); /* Memory allocation error */
 			return SQL_ERROR;
 		}
 		blob->textvalue = p;
diff --git a/src/odbc/sql2tds.c b/src/odbc/sql2tds.c
index 896f15e..25a7041 100644
--- a/src/odbc/sql2tds.c
+++ b/src/odbc/sql2tds.c
@@ -53,7 +53,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: sql2tds.c,v 1.78 2008/10/27 14:27:01 freddy77 Exp $");
+TDS_RCSID(var, "$Id: sql2tds.c,v 1.79 2008/11/12 10:38:15 freddy77 Exp $");
 
 static TDS_INT
 convert_datetime2server(int bindtype, const void *src, TDS_DATETIME * dt)
@@ -181,9 +181,10 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 
 	/* what type to convert ? */
 	dest_type = odbc_sql_to_server_type(dbc->tds_socket, drec_ipd->sql_desc_concise_type);
-	if (dest_type == TDS_FAIL)
-		/* TODO fill error */
+	if (dest_type == TDS_FAIL) {
+		odbc_errs_add(&stmt->errs, "07006", NULL);	/* Restricted data type attribute violation */
 		return SQL_ERROR;
+	}
 	tdsdump_log(TDS_DBG_INFO2, "trace\n");
 
 	/* get C type */
@@ -241,9 +242,10 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 	/* test source type */
 	/* TODO test intervals */
 	src_type = odbc_c_to_server_type(sql_src_type);
-	if (src_type == TDS_FAIL)
-		/* TODO fill error */
+	if (src_type == TDS_FAIL) {
+		odbc_errs_add(&stmt->errs, "07006", NULL);	/* Restricted data type attribute violation */
 		return SQL_ERROR;
+	}
 
 	/* we have no data to convert, just return */
 	if (!compute_row)
@@ -297,7 +299,7 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 		break;
 	case SQL_DEFAULT_PARAM:
 	case SQL_DATA_AT_EXEC:
-		/* TODO fill error */
+		odbc_errs_add(&stmt->errs, "07S01", NULL);	/* Invalid use of default parameter */
 		return SQL_ERROR;
 		break;
 	default:
@@ -310,7 +312,7 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 			case SQL_C_BINARY:
 				break;
 			default:
-				/* TODO fill error */
+				odbc_errs_add(&stmt->errs, "HY090", NULL);
 				return SQL_ERROR;
 			}
 			len = SQL_LEN_DATA_AT_EXEC(sql_len);
@@ -323,7 +325,7 @@ odbc_sql2tds(TDS_STMT * stmt, const struct _drecord *drec_ipd, const struct _dre
 			case SQL_LONGVARBINARY:
 				break;
 			default:
-				/* TODO fill error */
+				odbc_errs_add(&stmt->errs, "HY090", NULL);
 				return SQL_ERROR;
 			}
 		}

